﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Web;
using SyncfusionMvcApplication10;
using Syncfusion.Linq;
using SyncfusionMvcApplication10.Grid;
using System.Collections;
namespace SyncfusionMvcApplication10.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            var DataSource = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.datasource = DataSource;
            return View();
        }
        public ActionResult BatchUpdate(string key, List<OrdersView> changed, List<OrdersView> added, List<OrdersView> deleted)
        {
            var Data = new NorthwindDataContext().OrdersViews;

            if (added != null)
            {
                for (var add = 0; add < added.Count(); add++)
                {
                    /* Parse the string to Date
                    * It will change to its original value
                    * Since CustomerID is the string column
                    * We cannot assign Parsed date back to original value
                    */
                    DateTime dat = DateTime.Parse(added[add].CustomerID);
                    Data.InsertOnSubmit(added[add]);
                }
            }
            if (changed != null)
            {
                for (var up = 0; up < changed.Count(); up++)
                {
                    /* Parse the string to Date
                     * It will change to its original value
                     * Since CustomerID is the string column
                     * We cannot assign Parsed date back to original value
                    */
                    DateTime dat = DateTime.Parse(changed[up].CustomerID);
                    OrdersView data = Data.Where(o => o.OrderID == changed[up].OrderID).FirstOrDefault();
                    data.CustomerID = changed[up].CustomerID;
                    data.OrderDate = changed[up].OrderDate;
                    data.Freight = changed[up].Freight;
                }
            }
            if (deleted != null)
            {
                for (var del = 0; del < deleted.Count(); del++)
                {
                    Data.DeleteOnSubmit(deleted[del]);
                }
            }
            return Json(Data.ToList(), JsonRequestBehavior.AllowGet);
        }
        public ActionResult BatchData(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable Data = new NorthwindDataContext().OrdersViews.ToList();
            int count = 0;
            DataOperations operation = new DataOperations();
            count = Data.AsQueryable().Count();
            if (dm.Skip != null)
                Data = operation.PerformSkip(Data, dm.Skip);
            if (dm.Take != null)
                Data = operation.PerformTake(Data, dm.Take);
            var result = Data;
            return Json(new { result = result, count = count }, JsonRequestBehavior.AllowGet);
        }

    }
}
